Attribute VB_Name = "WaveSolder"
DefLng A-Z
'Magneto (C) 2004-2007 by EPTO (A)
'Mail: epto@usa.com
'Questo modulo gestisce gli algoritmi di
'purificazione delle onde
'Elimina e rileva le interferenze, i rimbalzi dell'onda
'e skazzi vari del wave

Type DynaNorm
    ii  As Long
    ff  As Long
    Amp As Integer
    Pol As Integer
    Can As Boolean
    End Type

Global Const MAXTOLFM = 3
Global Const RTE_WAVE = -8

Global Wpk() As DynaNorm            'Lista normalizzazioni
Global MaxWpk As Long

Global MpTolerance As Single        'Tolleranza di picco
Global CutZero As Boolean           'Taglia i picchi sotto soglia

Global Gamp() As Boolean            'Matrici di pulitura
Global GQan() As Integer
Global Piccomini                    'Picco Minimo

Sub DynaNorm()                      'Normalizzatore dinamico
lim = (NoiseLevel + Minimo) \ 2

    For Ax = 0 To MaxWpk
        am = Wpk(Ax).Amp
        If am > lim Then
            WaveNorm 20000, Wpk(Ax).ii, Wpk(Ax).ff
            WpkSmooth Ax
            Else
            If CutZero Then WaveTrim Wpk(Ax).ii, Wpk(Ax).ff
            
            End If
    Next

End Sub

Sub GetWaveMatrix()                 'Crea le matrici dell'onda
ReDim Gamp(255)
ReDim GQan(255)
Piccomini = GetPiccoMini(NoiseLevel, 512)

    For Ax = 0 To MaxWpk
        
        cval = Wpk(Ax).Amp \ 128
        Gamp(cval) = True
        
        GQan(cval) = GQan(cval) + 1
        
        Next

    n = NoiseLevel \ 128
    For Ax = 0 To n
    Gamp(Ax) = False
    Next
    
End Sub

Function GetMinSoglia()             'Rileva la solgia minima
Min = 65535
    
    For Ax = 0 To 255
        If Gamp(Ax) Then
            vl = GQan(Ax)
            If vl < Min Then Min = vl: QU = Ax
            'If vl > Min Then Exit For
            End If
    Next Ax

minpcm = 128 + QU * 256
If Piccomini < minpcm And Piccomini <> 0 Then minpcm = 128 + (minpcm + Piccomini) / 2
GetMinSoglia = mincpm
    
End Function

Function GetPiccoMini(VNoise, mPtol)        'Rileva il picco minimo

VMini = -1

Dim Passo2 As Boolean
If mPtol = 0 Then mPtol = VNoise



Mini = 0
uwpk = MaxWave / 2    'Freq Massima 22050Hz

'1 Dividiamo le onde per Zero Crossing:

    ReDim Wpk(uwpk)
    
MaxWpk = 0
    
LastPolo = 0

Wpk(0).ii = 0
Wpk(0).Pol = 0

    For Ax = 0 To MaxWave
    mo = Wave(Ax)
    Polo = 1
    If mo < 0 Then mo = -mo: Polo = -1
    If mo <= Noise Then Polo = 0
    If Polo <> LastPolo Then
        Wpk(MaxWpk).ff = Ax - 1
        If Wpk(MaxWpk).ff - Wpk(MaxWpk).ii > 8 Then
        MaxWpk = MaxWpk + 1
        Wpk(MaxWpk).ii = Ax
        Wpk(MaxWpk).Pol = Polo
        LastPolo = Polo
        End If
        End If
    Next Ax
    
MaxWpk = MaxWpk - 1 'Via i cancelletti vari
    
'2 Ricavo tutte le ampliezze delle sezioni

    For Ax = 0 To MaxWpk
    Wpk(Ax).Amp = WaveGetMax(Wpk(Ax).ii, Wpk(Ax).ff)
    Next
    Wpk(0).Amp = VNoise + 1
    
rax = GetMinorPeak(lastmin)
lastmin = Wpk(rax).Amp

Wpk(rax).Can = True
    For rax = 0 To MaxWpk
        id = GetMinorPeak(Amp)
        Amp = Wpk(id).Amp
        Wpk(id).Can = True

        delta = Amp - lastmin
  
        If delta >= mPtol Then
            Passo2 = True
            VMini = Amp
            Exit For
            End If
            
        lastmin = Amp
        
    Next

If Passo2 = False Then
    'Err.Raise RTE_WAVE, file$, "Impossibile calcolare l'onda minima! Prova a registrare un segnale pi potente e definito."
    'MsgBox file$ + ": Impossibile calcolare l'onda minima! Prova a registrare un segnale pi potente e definito.", vbCritical, "Errore Wave"
    WLog.AddItem "WAV_PICCOMINI", "Impossibile calcolare l'onda minima!", True
    Resetta
      
    ReDim Wpk(0)
    MaxWpk = -1
    Exit Function
    End If

GetPiccoMini = VMini

End Function

Sub WaveTrim(ii, ff)                'Cancella un pezzo
    For Ax = ii To ff
    Wave(Ax) = 0
    Next
End Sub

Function GetMinorPeak(Min)          'Trpova il picco minimo

id = 0
Min = 65535
    
    For Ax = 0 To MaxWpk
    
        If Wpk(Ax).Can = False Then
            BX = Wpk(Ax).Amp
            If BX <= Min Then Min = BX: id = Ax
            End If
            
    Next
GetMinorPeak = id
End Function

Sub TagliaRimbalzi()                'Elimina i rimbalzi

    For Ax = 0 To MaxWpk
        If Wpk(Ax).Can Then WaveTrim Wpk(Ax).ii, Wpk(Ax).ff
    Next

End Sub

Sub RemoveRebound()             'Elimina i rimbalzi dal ternario
Dim wp As DynaNorm
    
 For rax = 0 To MaxWpk
 wp = Wpk(rax)
    wp.Amp = WaveGetMax((Wpk(rax).ii), (Wpk(rax).ff))
    
        For Ax = wp.ii To wp.ff
            mo = Wave(Ax)
            If mo < 0 Then mo = -mo
            If mo = wp.Amp Then Pox = Ax: Exit For
        Next
        
 
        
          Min = wp.Amp
        For Ax = Pox To wp.ii Step -1
            mo = Wave(Ax)
            If mo < 0 Then mo = -mo
            
            If mo < Min Then Min = mo
            'If mo > Min Then Trin(Ax) = 0
            If mo > Min Then Wave(Ax) = 0
            
            Next

        
        Min = wp.Amp
        For Ax = Pox To wp.ff
            mo = Wave(Ax)
            If mo < 0 Then mo = -mo
            
            If mo < Min Then Min = mo
            'If mo > Min Then Trin(Ax) = 0
            If mo > Min Then Wave(Ax) = 0
            
            Next

      
 Next rax
If SETG.RemoveCut Then RemoveCut
End Sub

Sub WpkSmooth(id)               'Smooth di blocco
    For Ax = Wpk(id).ii To Wpk(id).ff
        BX = Ax
        If BX = 0 Then BX = 1
        If BX = MaxWave Then BX = MaxWave - 1
        
        pcm = (0& + Wave(BX - 1) + Wave(BX) + Wave(BX + 1)) \ 3&
        Wave(BX) = pcm
        
    Next Ax
    
End Sub

Function Affidabilita(Tk)       'Controlla se una tramama ternaria  affidabile in frequenza
ii = Skeda.Token(Tk).WpII
ff = Skeda.Token(Tk).WpFF
If ii = 0 And ff = 0 Or Layer1 = False Or Layer2 = False Then Exit Function 'Non  supportato da tutti i files STM

ReDim pmatrix(255)
    For Ax = 0 To MaxObj
    If (Obj(Ax).Pox >= ii And Obj(Ax).Pox <= ff) And (Obj(Ax).Tipo = positivo Or Obj(Ax).Tipo = positivo) Then
        fr = Obj(Ax).Size \ 4
        If fr < 256 Then pmatrix(fr) = pmatrix(fr) + 1
        End If
   
    Next Ax
BX = 0
For Ax = 0 To 255
If pmatrix(Ax) Then
    BX = BX + 1
    Debug.Print "PMT "; Ax, pmatrix(Ax)
    End If
    
Next

If BX > MAXTOLFM Then BX = -BX

Affidabilita = BX

End Function

Function AffidabilitaF(Tk)      'Controlla se una tramama ternaria  affidabile in ampliezza
ii = Skeda.Token(Tk).WpII
ff = Skeda.Token(Tk).WpFF
ReDim amtr(255)
If ii = 0 And ff = 0 Or Layer1 = False Or Layer2 = False Then Exit Function


    For Ax = 0 To MaxWpk
    
    If Wpk(Ax).ii >= ii And Wpk(Ax).ff <= ff Then
        
        am = WaveGetMax(Wpk(Ax).ii, Wpk(Ax).ff)
        If am > NoiseLevel And am > Minimo Then
            am = am \ 1024
            amtr(am) = amtr(am) + 1
            
            End If
        
        End If
    
    Next

cx = 0
For Ax = 0 To 255
If amtr(Ax) Then cx = cx + 1
Next
If cx > 12 Then cx = -cx
AffidabilitaF = cx

End Function

Sub ControllaStabilita()        'Controlla l'affidabilit delle trame settando il valore skeda.token().ok
    
    For Ax = 0 To Skeda.MaxTokens
    t0 = Affidabilita(Ax)
    t1 = AffidabilitaF(Ax)
    t00 = t0
    t01 = t1
    Skeda.Token(Ax).ANF = t0
    Skeda.Token(Ax).ANM = t1
    
    Debug.Print "TOKEN AFF. ", Ax; t0; t1
    
    t2 = t0
    If t1 < 0 Then t2 = t1
    
            

        Skeda.Token(Ax).Ok = (t2 >= 0)
             
    Debug.Print "AFFIDABILITA'", Ax; Skeda.Token(Ax).Ok
            
    Next
    
End Sub

Sub DynaNormBlk(ii, ff, Cut0 As Boolean)    'Normalizzazione dinamica in blocco
lim = (NoiseLevel + Minimo) \ 2

For Ax = 0 To MaxWpk
    If Wpk(Ax).ii >= ii And Wpk(Ax).ff <= ff Then
            am = Wpk(Ax).Amp
            If am > lim Then
                WaveNorm 20000, Wpk(Ax).ii, Wpk(Ax).ff
                WpkSmooth Ax
                Else
                If Cut0 Then WaveTrim Wpk(Ax).ii, Wpk(Ax).ff
                
                End If
    End If
Next

End Sub

Sub DynaBadTram()

    For CTk = 0 To Skeda.MaxTokens
        If Skeda.Token(CTk).Ok = False Then DynaNormBlk Skeda.Token(CTk).WpII, Skeda.Token(CTk).WpFF, False
    Next CTk

End Sub

Sub RilevaFondo(Rfondo, Rminimo)    'Restituisce il fondo ed il valore minimo per DynaNorm
ReDim mtr(255) As Integer   'Matrice Wave
stx = MaxWave \ 640         'Reticolo Orizzontale
Max = 0

    'Analizza l'onda per quanti di tempo in 640 blocchi per valore complessivo di onda

    For Ax = 0 To 640
    I = Ax * stx
    F = (Ax + 1) * stx
    If F > MaxWave Then F = MaxWave
    If I > MaxWave Then I = MaxWave
    CV = WaveGetMax(I, F) / 256
    If CV > Max Then Max = CV       'Valore Massimo
    mtr(CV) = mtr(CV) + 1           'Creazione matrice di passaggio per valore (Reticolo Verticale)
    Next

I = Max - 16        '16 = Valore di default empirico del fondo
F = Max + 16
If I < 16 Then I = 16: WLog.AddItem "WAV_NOISE", "Segnale troppo basso o confuso!", True
If F > 255 Then F = 255

    For Ax = I To F     'I valori del segnale non sono disturbi!
    mtr(Ax) = 0
    Next

maxv = GetMax(mtr(), 0, 255, Poxm)  'Trova la posizione del valore (di fondo + usato [ Centro dell'onda del fondo])

Rfondo = (1 + (Poxm * 2)) * 256     'Converte il valore in PCM
Rminimo = Rfondo + 256              'Valore minimo in PCM

End Sub

Sub RemoveCut()

    For Ax = 0 To MaxWave
    pcm = Wave(Ax)
    mo = pcm
    If mo < 0 Then mo = -mo
    If mo > Fondo Then lv = pcm
    Wave(Ax) = lv
    Next Ax

End Sub
