Attribute VB_Name = "CheckDll"
DefLng A-Z

Private Const STANDARD_RIGHTS_ALL As Long = &H1F0000
Private Const STANDARD_RIGHTS_READ As Long = &H20000
Private Const KEY_QUERY_VALUE As Long = &H1
Private Const KEY_SET_VALUE As Long = &H2
Private Const KEY_CREATE_SUB_KEY As Long = &H4
Private Const KEY_ENUMERATE_SUB_KEYS As Long = &H8
Private Const KEY_NOTIFY As Long = &H10
Private Const KEY_CREATE_LINK As Long = &H20
Private Const REG_OPTION_NON_VOLATILE As Long = 0
Private Const STANDARD_RIGHTS_WRITE As Long = &H20000
Private Const SYNCHRONIZE As Long = &H100000

Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegFlushKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, lpcbName As Long, lpReserved As Long, ByVal lpClass As String, lpcbClass As Long, ByVal lpftLastWriteTime As Long) As Long
Private Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" (ByVal hKey As Long, ByVal lpClass As String, lpcbClass As Long, lpReserved As Long, lpcSubKeys As Long, lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, lpftLastWriteTime As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, ByVal lpSecurityAttributes As Long, phkResult As Long, lpdwDisposition As Long) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long

Public Enum ChiaviPrincipali
    CHIAVE_APERTA = 0
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_CONFIG = &H80000005
    HKEY_CURRENT_USER = &H80000001
    HKEY_DYN_DATA = &H80000006
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_PERF_ROOT = HKEY_LOCAL_MACHINE
    HKEY_PERFORMANCE_DATA = &H80000004
    HKEY_USERS = &H80000003
End Enum

Public Enum ChiaviSecurity
    KEY_UNKNOWN = 0
    KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
    KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
    KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
End Enum

Public Enum TipoValoriRegistro
    REG_NONE = 0
    REG_SZ = 1
    REG_EXPAND_SZ = 2
    REG_BINARY = 3
    REG_DWORD = 4
    REG_DWORD_LITTLE_ENDIAN = 4
    REG_DWORD_BIG_ENDIAN = 5
    REG_LINK = 6
    REG_MULTI_SZ = 7
    REG_RESOURCE_LIST = 8
End Enum

Private lngKeyValue As Long
Private lngKeySecurity As Long

Function GetDllByClsId(CLSID$) As Variant

k = OpenKey(HKEY_CLASSES_ROOT, "CLSID")
k = OpenKey(CHIAVE_APERTA, CLSID$)
k = OpenKey(CHIAVE_APERTA, "InProcServer32")
GetDllByClsId = ReadKey()
CloseKey

End Function

Public Function ReadKey(Optional ByVal NomeValore As String, Optional ByRef TipoDati As TipoValoriRegistro) As Variant

    Dim AmpiezzaBuffer As Long
    Dim Buffer() As Byte
    TipoDati = REG_NONE
    Call RegQueryValueEx(lngKeyValue, NomeValore, ByVal 0&, TipoDati, ByVal 0&, AmpiezzaBuffer)
    If AmpiezzaBuffer > 0 Then
        ReDim Buffer(AmpiezzaBuffer - 1)
        Call RegQueryValueEx(lngKeyValue, NomeValore, ByVal 0&, ByVal 0&, Buffer(0), AmpiezzaBuffer)
        Select Case TipoDati
            Case REG_SZ
                ReadKey = Left$(StrConv(Buffer, vbUnicode), AmpiezzaBuffer - 1)
            Case REG_NONE, REG_BINARY, REG_EXPAND_SZ, REG_MULTI_SZ
                ReadKey = Buffer
            Case REG_DWORD, REG_DWORD_LITTLE_ENDIAN
                If UBound(Buffer) = 3 Then
                    ReadKey = CDbl(Buffer(0) + Buffer(1) * 256& + Buffer(2) * 65536) + Buffer(3) * 16777216#
                Else
                    ReadKey = Buffer
                End If
                End Select
    End If
    If AmpiezzaBuffer = 0 Then ReadKey = Null
    Erase Buffer
End Function

Public Function OpenKey(ByVal ChiavePrincipale As ChiaviPrincipali, ByVal SottoChiave As String) As Long
    Dim oldKey As Long
    oldKey = lngKeyValue
    If ChiavePrincipale = CHIAVE_APERTA Then ChiavePrincipale = lngKeyValue
    lngKeyValue = 0
    Call RegOpenKeyEx(ChiavePrincipale, SottoChiave, ByVal 0&, lngKeySecurity, lngKeyValue)
    OpenKey = lngKeyValue
    Call RegCloseKey(oldKey)
End Function

Public Sub CloseKey()
    Call RegCloseKey(lngKeyValue)
    lngKeyValue = 0
End Sub

Sub ConfiguraDll(Lab As Label, Optional rerun As Boolean = False)
Dim V As Variant
'429 430 440 DLL 453 REG 463
Z = FreeFile
Open Mypath$ + "MAGNETODLL.LST" For Input As Z
Lab = "Correzione DLL in corso..."
While Not EOF(Z)
Input #Z, dl$
Input #Z, cl$
Input #Z, typ$
Line Input #Z, info$
If Len(cl$) Then
    Lab = "Ricerca di " + cl$
    V = GetDllByClsId(cl$)
    If VarType(V) = vbNull Then cdll$ = "" Else cdll$ = CStr(V)
    F = 0
    If Dir(cdll$) <> Mypath$ + dl$ And cdll$ <> "" Then
        If Dir$(cdll$) = "" Then
            F = 2
            MsgBox "Il componente: " + CLSID$ + vbCrLf + "Ovvero: " + info$ + vbCrLf + "Che crea il conflitto sul file: " + vbCrLf + dl$ + vbCrLf + "Registrazione corrotta", vbExclamation, "Errore"
            Else
            F = (MsgBox("Il componente: " + CLSID$ + vbCrLf + "Ovvero: " + info$ + vbCrLf + "Del file: " + dl$ + vbCrLf + "Va in conflitto con il file: " + cdll$ + vbCrLf + "Registrare la componente usata da Magneto? ", vbQuestion + vbYesNo + vbDefaultButton1, "Controllo DLL") = vbYes)
            End If
        
        If F Then
            Lab = "DeRegistrazione CLSID"
            DoEvents
            If F <> 2 Then Shell Mypath$ + "REGSVR32 /U /S " + Chr(34) + cdll$ + Chr(34)
            Shell Mypath$ + "REGSVR32 /U /S " + Chr(34) + Mypath$ + dl$ + Chr(34)
            If typ$ = "R" Then
                Lab = "Registrazione CLSID"
                Shell Mypath$ + "REGSVR32 /S " + Chr(34) + Mypath$ + dl$ + Chr(34)
                End If
            End If
        
        End If
        End If
    'End If
    
If F = 0 Then
    If Dir$(Mypath$ + dl$) = "" Then
        MsgBox "Non  stato trovato il file '" + dl$ + "' nella directory di magneto!", vbCritical, "Errore"
        Else
        Lab = "Correzione di " + dl$ + " ..."
        DoEvents
        Shell Mypath$ + "REGSVR32 /U /S " + Chr(34) + Mypath$ + dl$ + Chr(34)
        DoEvents
        If typ$ = "R" Then
                Lab = "Registrazione File"
                Shell Mypath$ + "REGSVR32 /S " + Chr(34) + Mypath$ + dl$ + Chr(34)
                End If
        End If
    End If
    
Wend
Close #Z
Lab = "Completo"
If Not rerun Then Exit Sub
If MsgBox("Occorre riavviare il programma da capo." + vbCrLf + "Riavviare Ora?", vbQuestion + vbYesNo + vbDefaultButton1, "Controllo DLL") = vbYes Then Shell Mypath$ + App.EXEName
End
End Sub


