VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LPT"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
DefLng A-Z
'
' LPT Class V1.0 By EPTO (A)
' Tutti i diritti sono miei e me li tengo!
'
' Questa Classe permette di utilizzare attraverso la libreria NINOUT32
' La porta parallela su qualunque indirizzo si trovi.
' Sono state inserite delle routines particolari per utilizzare
' anche uno stream di dati in uscita ad una certa velocit ed un sistema
' compatibile con i pi comuni SIPO e PISO per aumentare gli ingressi
' e le uscite della porta.

Private IO As NINOUT32.CNINOUT32        'E' necessario installare questa libreria
Private BaseAddr As Long
Private CurLptI As Integer
Private Lpt15
Public ResetOnExit As Boolean
Private AbortOperation As Boolean
Private PortWidth%, PortHeight%
Private PLCI%(), PLCO%(), SipoMode As Boolean
Private Mips, Los
Private AddressList(15)

Public Sub SetIOPortArray(N, Addr)
    AddressList(N And 15) = Addr And 65535
End Sub

Public Sub SetSIPOPISOMode(ByteXPort, NumPort)

    PortWidth% = (ByteXPort * 8) - 1
    PortHeight% = NumPort
    
    ReDim PLCO%(PortHeight%, PortWidth%)
    ReDim PLCI%(4, PortWidth%)
    
    SipoMode = True

End Sub

Public Function GetSPin(Port, Num) As Boolean

    If Port < 0 Then Exit Function
    If Port > 4 Then Exit Function
    If Num < 0 Then Exit Function
    If Num > PortWidth% Then Exit Function
    
    SPin = PLCI%(Port, Num) <> 0

End Function

Public Sub SetSpin(Port, Num, Bit As Boolean)
    
    If Port < 0 Then Exit Sub
    If Port > 4 Then Exit Sub
    If Num < 0 Then Exit Sub
    If Num > PortWidth% Then Exit Sub

PLCO%(Port, Num) = Bit

End Sub

Public Sub PrepareArray(InArray() As Byte, OutArray() As Byte)

    ReDim InArray(PortWidth% / 8, 4)
    ReDim OutArray(PortWidth%, PortHeight%)
    
End Sub

Public Sub SerialRefresh(InArray() As Byte, OutArray() As Byte)

    For Y = 0 To PortHeight%
        
        For X = 0 To PortWidth% Step 8
        by = OutArray(X / 8, Y)
        
            For CBI = 0 To 7
            PLCO%(Y, X + CBI) = (by And 2 ^ CBI) <> 0
            Next CBI
        
        Next X
        
    Next Y
    
    SIPOPISO
    
    For Y = 0 To 4
    
        For X = 0 To PortWidth% Step 8
        by = 0
            For CBI = 0 To 7
            If PLCI%(Y, X + CBI) <> 0 Then by = by Or 2 ^ CBI
            Next CBI
            
        InArray(X / 8, Y) = by
        Next X
    Next Y

End Sub

Public Sub InitSIPOPISO()

    For AX = 0 To 1
    SIPOPISO
    Next AX

End Sub

Public Sub SIPOPISO()

IO.Out BaseAddr, 0
IO.Out BaseAddr + 2, 0
IO.Out BaseAddr + 2, 1

For AX = 0 To PortWidth%

    For ay = 0 To PortHeight%
    oo = oo Or ((2 ^ (ay + 1)) And PLCO%(ay, AX) <> 0)
    Next ay
        
IO.Out BaseAddr, oo
ii = IO.Inp(BaseAddr + 1)
IO.Out BaseAddr, oo Or 1

        PLCI%(0, AX) = ((ii And 128) = 0)   '11
        PLCI%(1, AX) = ((ii And 32) <> 0)   '12
        PLCI%(2, AX) = ((ii And 16) <> 0)   '13
        
        PLCI%(3, AX) = ((ii And 8) <> 0)    '15
        'PLCI%(4, AX) = ((ii And 4) <> 0)    '16         ''NON  corretto il pin!
        PLCI%(4, AX) = ((ii And 64) <> 0)   '10

Next AX
    
End Sub

Public Sub Abort()
    AbortOperation = True
End Sub

Private Sub Class_Initialize()
If ResetOnExit And BaseAddr <> 0 Then IO.Out BaseAddr, 0
Set IO = New NINOUT32.CNINOUT32
Lpt15 = &H378

X = FirstLptPresent
SetLpt (X)
SetSIPOPISOMode 2, 7
SipoMode = False
End Sub

Private Sub Class_Terminate()
If ResetOnExit Then
    If SipoMode Then
        Dim I() As Byte
        Dim o() As Byte
        PrepareArray I(), o()
        SerialRefresh I(), o()
        Else
        IO.Out BaseAddresS, 0
        End If
    End If
Set IO = Nothing
End Sub

Public Function LoadAddress(Optional fi$ = "") As Boolean

    For AX = 0 To 15
    AddressList(AX) = 0
    Next AX
    
If fi$ = "" Then fi$ = Replace(App.Path + "\", "\\", "\") + "LPT.INF"

Z = FreeFile
If Dir$(fi$) = "" Then Exit Function
    
    Open fi$ For Input As Z
    
    Do
        If EOF(Z) Then Exit Do
        Line Input #Z, d$
        d$ = UCase(Trim(d$))
        If InStr(d$, ";") = 0 Then
            l = InStr(d$, "=")
                If l Then
                    Id = Val(Mid(d$, 1, l - 1))
                    ad = Val(Mid(d$, l + 1))
                    AddressList(Id And 15) = AX And 65535
                    End If
                End If
    Loop
    
    Close #Z

LoadAddress = True

End Function

Public Function GetMips() As Long
If Mips = 0 Then StreamInit
GetMips = Mips
End Function

Public Sub StreamInit()
Mips = 0
    M& = Int(Timer)
    Do
    DoEvents
    Loop Until M& <> Int(Timer)
    M& = Int(Timer)
    Do
    Mips = Mips + 1
    Loop Until M& <> Int(Timer)
End Sub

Public Property Get CurLpt() As Integer
CurLpt = CurLptI
End Property

Public Sub Out(Dato As Byte)
IO.Out BaseAddr, Dato
End Sub

Public Function Inp() As Byte
    Inp = IO.Inp(BaseAddr)
End Function

Public Property Let CurLpt(ByVal v As Integer)
SetLpt (v)
End Property

Public Property Get BaseAddresS() As Long
BaseAddresS = BaseAddr
End Property

Public Property Let BaseAddresS(ByVal v As Long)
CurLptI = 0
BaseAddr = v
End Property

Public Sub PortPinInfo(N, IOInd As Long, NBit, ne As Boolean, I As Boolean, o As Boolean)
IOInd = BaseAddr
ne = False
NBit = 0
I = True

    If N = 1 Then I = True: ne = True: IOInd = BaseAddr + 2: NBit = 0: o = True
    If N > 1 And N < 10 Then I = False: ne = False: IOInd = BaseAddr: NBit = N - 2: o = True
    If N = 10 Then I = True: ne = False: IOInd = BaseAddr + 1: NBit = 6: o = False
    If N = 11 Then I = True: ne = True: IOInd = BaseAddr + 1: NBit = 7: o = False
    If N = 12 Then I = True: ne = False: IOInd = BaseAddr + 1: NBit = 5: o = False
    If N = 13 Then I = True: ne = False: IOInd = BaseAddr + 1: NBit = 4: o = False
    If N = 14 Then I = True: ne = True: IOInd = BaseAddr + 2: NBit = 1: o = True
    If N = 15 Then I = True: ne = False: IOInd = BaseAddr + 1: NBit = 3: o = False
    If N = 16 Then I = True: ne = False: IOInd = BaseAddr + 2: NBit = 2: o = True
    If N = 17 Then I = True: ne = True: IOInd = BaseAddr + 2: NBit = 3: o = True
    
If N < 1 Or N > 17 Then Err.Raise 5, "LPTClass", "Pin " + CStr(N) + " not connected!"
    
End Sub


Public Property Get Pin(N As Integer) As Boolean
Dim Bit As Boolean
Dim I As Boolean
Dim o As Boolean
Dim ne As Boolean

PortPinInfo (N), IOInd, NBit, ne, I, o

by = IO.Inp(IOInd)
Bit = (by And (2 ^ NBit)) <> 0
If ne Then Bit = Not NBit

Pin = Bit
 
End Property

Public Property Let Pin(N As Integer, ByVal Bit As Boolean)

Dim bitv As Boolean
Dim I As Boolean, o As Boolean
Dim ne As Boolean
bitv = Bit

PortPinInfo (N), IOInd, NBit, ne, I, o
If ne Then bitv = Not bitv

If o Then
        If Bit Then IO.BitSet IOInd, NBit Else IO.BitReset IOInd, NBit
    Else
        Err.Raise 5, "LPTClass", "The pin " + CStr(N) + " is for input only"
    End If

End Property

Public Sub SetCustomLpt(BaseAddresS As Long)
    Lpt15 = (BaseAddresS And 65535)
    If Lpt15 = 0 Then Lpt15 = &H378
    SetLpt 15
End Sub

Private Sub SetLpt(v)
BaseAddr = &H378
If v = 1 Then BaseAddr = &H378: CurLptI = 1
If v = 2 Then BaseAddr = &H278: CurLptI = 2
If v = 3 Then BaseAddr = &H3BC: CurLptI = 3
If v = 4 Then BaseAddr = &H2BC: CurLptI = 4
If v = 5 Then BaseAddr = &H368: CurLptI = 5
If v = 6 Then BaseAddr = &H268: CurLptI = 6
If v = 7 Then BaseAddr = &H358: CurLptI = 7
If v = 8 Then BaseAddr = &H258: CurLptI = 8
If v = 9 Then BaseAddr = &HC800&: CurLptI = 9

If v > 9 And v < 15 Then
    CurLptI = v
    If AddressList(v) <> 0 Then BaseAddr = AddressList(v) Else BaseAddr = ABSADDR(v)
    End If
If v = 15 And Lpt15 <> 0 Then BaseAddr = Lpt15: CurLptI = 15
If BaseAddr = 0 Then BaseAddr = &H378
End Sub

Private Function ABSADDR(N)

If v = 10 Then I = &HBC00&
If v = 11 Then I = &HC400&
If v = 12 Then I = &HC480&
If v = 13 Then I = &HC000&
If v = 14 Then I = &HC080&

ABSADDR = I
End Function

Public Function FindFirstLpt(MASK, maxtim As Integer) As Integer
If maxtim > 30 Then maxtim = 30

X = FirstLptPresent
If X Then
    If WaitForInsert(X, MASK, (maxtim)) Then
        FindFirstLpt = X
        Else
        FindFirstLpt = 0
        End If
    End If

End Function

Public Function LPTPresent(N) As Boolean
    SetLpt N
    Call IO.Out(BaseAddr, 0)
    LPTPresent = (IO.Inp(BaseAddr) = 0)
End Function

Public Function FirstLptPresent() As Integer
    For AX = 1 To 15
    If LPTPresent((AX)) Then
        FirstLptPresent = AX
        Exit For
        End If
    Next
End Function

Public Property Get Strobe() As Boolean
Strobe = Pin(1)
End Property

Public Property Let Strobe(ByVal v As Boolean)
Pin(1) = v
End Property

Public Property Get Ack() As Boolean
Ack = Pin(10)
End Property

Public Property Let Ack(ByVal v As Boolean)
Pin(10) = v
End Property

Public Property Get Busy() As Boolean
Busy = Pin(11)
End Property

Public Property Let Busy(ByVal v As Boolean)
Pin(11) = v
End Property

Public Property Get PE() As Boolean
PE = Pin(12)
End Property

Public Property Let PE(ByVal v As Boolean)
Pin(12) = v
End Property

Public Property Get AutoFd() As Boolean
AutoFd = Pin(14)
End Property

Public Property Let AutoFd(ByVal v As Boolean)
Pin(14) = v
End Property

Public Property Get Slct() As Boolean
Slct = Pin(13)
End Property

Public Property Let Slct(ByVal v As Boolean)
Pin(13) = v
End Property

Public Property Get Error() As Boolean
Error = Pin(15)
End Property

Public Property Let Error(ByVal v As Boolean)
Pin(15) = v
End Property

Public Property Get init() As Boolean
init = Pin(16)
End Property

Public Property Let init(ByVal v As Boolean)
Pin(16) = v
End Property

Public Property Get SlctIn() As Boolean
SlctIn = Pin(17)
End Property

Public Property Let SlctIn(ByVal v As Boolean)
Pin(17) = v
End Property


Public Property Get StreamRate() As Long
If Los = 0 Or Mips = 0 Then Exit Sub
StreamRate = (Mips / Los)

End Property

Public Property Let StreamRate(ByVal v As Long)
If v = 0 Then Exit Property
If misp = 0 Then StreamInit
    Los = Mips / v
End Property

Public Sub OutSb(Data() As Byte)

I = LBound(Data)
f = UBound(Data)
    
    For AX = I To f
    IO.Out BaseAddr, Data(AX)
    Next

End Sub

Public Sub StreamOut(Data() As Byte)
If Mips = 0 Then Err.Raise 5, "LPTClass", "Stream not initialized"
AbortOperation = False

I = LBound(Data)
f = UBound(Data)
    
    For AX = I To f
    IO.Out BaseAddr, Data(AX)
        For cx = 1 To Los
        M& = Int(Timer)
        Next cx
    If AbortOperation Then Exit For
    Next

End Sub

Public Function WaitForInsert(Port, MASK, maxtim) As Boolean
Dim Bit As Boolean
AbortOperation = False
    SetLpt (Port)
    
    IO.Out BaseAddr, MASK And 255
    A = (MASK And &HFFFF00) / 256
    IO.Out BaseAddr + 1, A And 255
    A = (MASK And &HFFFF00) / 256
    IO.Out BaseAddr + 2, A And 255
    
    ms0 = IO.Inp(BaseAddr + 1)
    ms1 = IO.Inp(BaseAddr + 2)
    
    For T = 0 To maxtim
        M& = Int(Timer)
            Do
            
            DoEvents
            s0 = IO.Inp(BaseAddr + 1)
            s1 = IO.Inp(BaseAddr + 2)
            If ms0 <> s0 Or ms1 <> s1 Then Bit = True: Exit Do
            
            Loop Until M& <> Int(Timer) Or AbortOperation
            
    If Bit Then Exit For
    Next T
WaitForInsert = Bit
End Function

Public Function VirtualLPTAddress(N)
    Nq = CurLptI
    A = BaseAddr
    SetLpt (N)
    q = BaseAddr
    BaseAddr = A
    CurLptI = Nq
VirtualLPTAddress = q
End Function

Public Function GetByte(I)
    
    GetByte = IO.Inp(BaseAddr + I)
    
End Function

Public Function SetByte(I, B)

    IO.Out BaseAddr + I, B

End Function

Public Function GetAllInsert(MASK, maxtim)
ReDim s0(15), s1(15)
ii = CurLptI
AbortOperation = False

    For AX = 1 To 15
    SetLpt (AX)
    IO.Out BaseAddr, 0
    s0(AX) = IO.Inp(BaseAddr + 1)
    s1(AX) = IO.Inp(BaseAddr + 2)
    Next AX
    DoEvents
    
    
For c = 0 To maxtim

    M& = Int(Timer)
    
        Do
        DoEvents
        
            For AX = 1 To 15
            SetLpt (AX)
            f = 0
            IO.Out BaseAddr, MASK And 255
            If s0(AX) <> IO.Inp(BaseAddr + 1) Then f = 1
            If s1(AX) <> IO.Inp(BaseAddr + 2) Then f = 1
            IO.Out BaseAddr, 0
            If f = 1 Then ril = AX: Exit For
            Next AX
        
        Loop Until M& <> Int(Timer) Or ril <> 0 Or AbortOperation
        
If ril <> 0 Or AbortOperation Then Exit For
Next c
If ril <> 0 Then SetLpt (ril) Else SetLpt (ii)
GetAllInsert = ril
End Function

Public Property Get StatusPort() As Byte
StatusPort = IO.Inp(BaseAddr + 1)
End Property

Public Property Let StatusPort(ByVal v As Byte)
IO.Out BaseAddr + 1, v
End Property

Public Property Get ControlPort() As Byte
ControlPort = IO.Inp(BaseAddr + 2)
End Property

Public Property Let ControlPort(ByVal v As Byte)
IO.Out BaseAddr + 2, v
End Property
