VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "INICom"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
DefLng A-Z
Private Const RTE_INIMOD = &HFC100000
Private Const RTE_INILOAD = 1
Private Const RTE_INIFILE = 2

Private INI As Collection

Private INIID As Collection
Private SubId As Collection
Private INILoaded As Boolean

Private Type INISection
    Nome As String
    P As New PropertyBag
    c As New Collection
    created As Boolean
    End Type
    
Private INIS As INISection
    
Public INIHeader As String


Public Function CountSections()
CountSections = INI.Count
End Function

Public Function CountParameters()
CountParameters = INIS.c.Count
End Function

Public Function GetSectionCollection() As Collection

    Dim c As New Collection
    Dim V As Variant
    
        For Each V In INIID
            c.Add V
            Next

Set GetSectionCollection = c

End Function

Public Sub CreateIniSection(Nome$)

    Set INIS.c = New Collection
    Set INIS.P = New PropertyBag
    INIS.Nome = Nome$
    INIS.created = True
End Sub

Public Sub CloseIniSection()

    If INIS.created = False Then
        INI.Remove INIS.Nome
        INIID.Remove INIS.Nome
        SubId.Remove INIS.Nome
        End If

        INI.Add INIS.P.Contents, INIS.Nome
        INIID.Add INIS.Nome, INIS.Nome
        SubId.Add INIS.c, INIS.Nome

End Sub
   
Public Sub CreateINIPar(Par$, Valo As Variant)

    INIS.c.Add Par$
    INIS.P.WriteProperty Par$, Valo
    INIS.created = True

End Sub
    
Public Sub SetINIPar(Par$, Valo As Variant)

Dim j As New PropertyBag
Dim V As Variant

    cx = INIS.c.Count
    
        For ax = 1 To cx
        
            s1$ = INIS.c.Item(ax)
            If s1$ <> Par$ Then
                j.WriteProperty s1$, INIS.P.ReadProperty(s1$)
                Else
                j.WriteProperty Par$, Valo
                End If
        Next ax
        
INIS.P.Contents = j.Contents
        
End Sub

Public Sub AddIniPar(Par$, Valo As Variant)

    INIS.P.WriteProperty Par$, Valo
    INIS.c.Add Par$

End Sub

Public Function GetINIPar(Par$) As Variant

    GetINIPar = INIS.P.ReadProperty(Par$)

End Function

Public Sub OpenIniSection(Nome$)
Dim V As Variant
    V = INI.Item(Nome$)
    Set INIS.c = SubId.Item(Nome$)
    INIS.Nome = Nome$
    INIS.P.Contents = V
    INIS.created = False
End Sub

Private Sub SaveIniSection(Z, II As Variant, SU As Variant)

    Dim j As New PropertyBag
    Dim c As Collection
    Dim V As Variant
    j.Contents = II
    
    Set c = SU
    
        cx = c.Count
        
        For ax = 1 To cx
        
            pn$ = c.Item(ax)
            
            V = j.ReadProperty(pn$)
            
            If VarType(V) = vbString Then
                st$ = V
                If InStr(st$, "=") > 0 Or InStr(st$, " ") > 0 Or st$ = "" Then
                    Print #Z, pn$; "="; Chr(34) + MKSlash(st$) + Chr$(34)
                    Else
                    Print #Z, pn$; "="; MKSlash(st$)
                    End If
                st$ = ""
                Else
                Print #Z, pn$; "="; CStr(V)
                End If
        
        Next ax
        

End Sub
Public Sub SaveINI(Optional Fo$ = "")
 If Fo$ = "" Then Fo$ = Replace(App.Path + "\" + App.EXEName + ".INI", "\\", "\")
 
 Z = FreeFile
 Open Fo$ For Output As Z
 
    cx = INIID.Count
    
        For ax = 1 To cx
        
            Print #Z, "["; INIID.Item(ax); "]"
            
            SaveIniSection Z, INI.Item(ax), SubId.Item(ax)
            
            Print #Z, ""
        Next ax
 
 Close #Z
End Sub

Public Sub INIRemoveNames()
    INILoaded = False
    Set INIID = EmptyCol
    Set SubId = EmptyCol
End Sub

Public Sub LoadINI(Optional fi$ = "")

INILoaded = True

Set INI = EmptyCol
Set INIID = EmptyCol
Set SubId = EmptyCol
Dim tmpl As Collection
Dim Sect As PropertyBag
Dim SectI As Collection
Dim var0 As Variant
    If fi$ = "" Then fi$ = Replace(App.Path + "\" + App.EXEName + ".INI", "\\", "\")
    
    Z = FreeFile
    Open fi$ For Input As Z
    
    Do
        If EOF(Z) Then Exit Do
        
        Line Input #Z, d$
        d$ = Trim(d$)
        
        If Len(d$) Then
            If Asc(d$) = 91 Then
                sectn$ = Mid(d$, 2)
                sectn$ = Mid(sectn$, 1, Len(sectn$) - 1)
                INIID.Add sectn$, sectn$
     
                  Set Sect = EmptySection
                  Set SectI = EmptyCol
                  
                    Do
                    If EOF(Z) Then Exit Do
                    sk = Seek(Z)
                    Line Input #Z, d$
                    d$ = Trim(d$)
                    If Len(d$) Then
                        If Asc(d$) = 91 Then
                            Seek #Z, sk
                            Exit Do
                            End If
                        
                        Set tmpl = EmptyCol
                        TokenEX d$, tmpl, "=", True, False
                        Sect.WriteProperty tmpl.Item(1), tmpl.Item(2)
                        SectI.Add tmpl(1)
                        End If
                        
                    Loop
                    
                    var0 = Sect.Contents
                    INI.Add var0, sectn$
                    SubId.Add SectI, sectn$
                    '   /
                
                End If
            End If
    Loop
    
    Close #Z
End Sub

Private Function EmptySection() As PropertyBag
    Dim PP As New PropertyBag
    Set EmptySection = PP
End Function

Public Sub UnloadINI()
    INILoaded = False
  Set INIID = EmptyCol
    Set SubId = EmptyCol
    Set INI = EmptyCol
End Sub

Public Function GetIni(Section$, Param$) As Variant
Static LastSection$
sec$ = Section$
If sec$ = "" Then sec$ = LastSection$
LastSection$ = sec$


Dim va As Variant

'Set va = INI.Item(sec$)
'pr.Contents = va
'Set GetIni = pr.ReadProperty(param$)
GetIni = ReadPar(INI.Item(sec$), Param$)
End Function

Private Function ReadPar(SE As Variant, Param$) As Variant

    Dim j As New PropertyBag
    j.Contents = SE
    
    ReadPar = j.ReadProperty(Param$)

End Function

Public Function GetIniSectionBin(Section$) As PropertyBag
Dim j As New PropertyBag
Dim V As Variant
   V = INI.Item(Section$)
   j.Contents = V
Set GetIniSectionBin = j
End Function

Private Sub SetIniSection(SE As INISection)
Dim V As Variant

V = SE.P.Contents
INI.Remove SE.Nome
INI.Add V, SE.Nome
SubId.Remove SE.Nome
SubId.Add SE.c, SE.Nome
INIID.Remove SE.Nome
INIID.Add SE.Nome

End Sub

Public Sub SaveCFG(Optional Fo$ = "", Optional InNames As Boolean = True)

Dim va As Variant
If INIHeader = "" Then
    va = App.Title + " V" + CStr(App.Major) + "." + CStr(App.Minor) + "." + CStr(App.Revision)
    Else: va = INIHeader
    End If

    If Fo$ = "" Then Fo$ = Replace(App.Path + "\" + App.EXEName + ".CFG", "\\", "\")
    Z = FBCreat(Fo$)
    
    dd& = RTE_INIMOD
    Put #Z, 1, dd&
    dd& = 0
    Put #Z, , va
    
    PutCollection Z, INI
    
    If InNames And INILoaded Then
        Put #Z, , InNames
        PutCollection Z, INIID
        PutCollection Z, SubId
        Else
        Put #Z, , dd&
        End If
    Close #Z

End Sub

Public Sub LoadCfg(Optional fi$ = "")
UnloadINI
Dim va As Variant

    If fi$ = "" Then fi$ = Replace(App.Path + "\" + App.EXEName + ".CFG", "\\", "\")


    Z = FreeFile
    Open fi$ For Binary As Z
    Get #Z, 1, dd&
    If dd& <> RTE_INIMOD Then
        Close #Z
        Err.Raise RTE_INIMOD + RTE_INIFILE, "LoadCfg", "Questo file di configurazione non  valido"
        End If
    
    
    If INIHeader = "" Then
        st$ = App.Title + " Ver " + CStr(App.Major) + "." + CStr(App.Minor) + "." + CStr(App.Revision)
        Else
        st$ = INIHeader
        End If
        
    Get #Z, , va
    If va <> st$ Then
        Close #Z
        Err.Raise RTE_INIMOD + RTE_INIFILE, "LoadCfg", "Questo file di configurazione  pe ril programma:" + vbCrLf + va
        End If
    
    
    Set INI = GetCollection(Z)
    Get #Z, , INILoaded
    If INILoaded Then
        Set INIID = GetCollection(Z)
        Set SubId = GetCollection(Z)
        MakeNames
        End If

Close #Z

End Sub

Private Sub MakeNames()

    Dim II As New Collection
    Dim Sb As New Collection
    Dim Id As New Collection
    
    cx = INIID.Count
    
        For ax = 1 To cx
        
        n$ = INIID.Item(ax)
        
        II.Add INI.Item(ax), n$
        Sb.Add SubId.Item(ax), n$
        Id.Add n$, n$
        
        Next ax
    
Set INI = II
Set SubId = Sb
Set INIID = Id
INILoaded = True

End Sub

Private Sub Class_Initialize()
UnloadINI
End Sub
